Status: Resolved Priority: Should have
Author: Tymoteusz Motylewski Category:
Created: 2014-02-28 Assigned To:
Updated: 2014-03-06 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git master
Subject: Interface incompatibility - PackageManager
Description

PackageManagerInterface contains following method declaration:
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap);

however in the PackageManager (which implements \TYPO3\Flow\Package\PackageManagerInterface)
it is implemented like this:
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap, $packagesBasePath = FLOW_PATH_PACKAGES,
$packageStatesPathAndFilename = '') {

this is wrong and will fatal on some versions of php, see http://php.net/manual/en/language.oop5.interfaces.php
"The class implementing the interface must use the exact same method signatures as are defined in the interface. Not doing so will
result in a fatal error."

It also fatals when running unit tests on hhvm (of CMS)

Related issues:
related to TYPO3.Flow - Bug # 54549: PackageManager::createPackage is incompa... New 2013-12-21
related to Core - Bug # 56660: Interface incompatibility - PackageManager ini... Resolved 2014-03-07

Associated revisions
Revision bff16094 - 2014-03-05 22:12 - Alexander Berl

[BUGFIX] PackageManager initialize() signature is incompatible

PackageManagerInterface contains following method declaration::
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap);

however in the PackageManager the signature is::
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap,
    $packagesBasePath = FLOW_PATH_PACKAGES,
    $packageStatesPathAndFilename = '')

This will create a fatal error on some versions of php and when running
unit tests on hhvm (of CMS), see
http://php.net/manual/en/language.oop5.interfaces.php:

"The class implementing the interface must use the exact same method
signatures as are defined in the interface. Not doing so will result
in a fatal error."
This change updates the method signature of the PackageManager to be in
line with the interface.

Change-Id: I94cf40fb788861f2e4c9e656bea57a0ff2354113
Fixes: #56409
Releases: master, 2.1

Revision 6c4fbd6d - 2014-03-06 12:11 - Alexander Berl

[BUGFIX] PackageManager initialize() signature is incompatible

PackageManagerInterface contains following method declaration::
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap);

however in the PackageManager the signature is::
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap,
    $packagesBasePath = FLOW_PATH_PACKAGES,
    $packageStatesPathAndFilename = '')

This will create a fatal error on some versions of php and when running
unit tests on hhvm (of CMS), see
http://php.net/manual/en/language.oop5.interfaces.php:

"The class implementing the interface must use the exact same method
signatures as are defined in the interface. Not doing so will result
in a fatal error."

This change updates the method signature of the PackageManager to be in
line with the interface.

Change-Id: I94cf40fb788861f2e4c9e656bea57a0ff2354113
Fixes: #56409
Releases: master, 2.1

History
#1 - 2014-02-28 15:51 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27948

#2 - 2014-03-05 22:12 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27948

#3 - 2014-03-06 12:11 - Gerrit Code Review
Patch set 1 for branch 2.1 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/28100

#4 - 2014-03-06 12:36 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:bff1609471a84b50e0358f1d3ce0d25d7322f155.
